Class: Bundler::CLI::Platform

Inherits:
Object
  • Object
show all
Defined in:
lib/bundler/cli/platform.rb

Instance Attribute Summary collapse

Instance Method Summary collapse

Constructor Details

#initialize(options) ⇒ Platform

Returns a new instance of Platform



6
7
8
# File 'lib/bundler/cli/platform.rb', line 6

def initialize(options)
  @options = options
end

Instance Attribute Details

#optionsObject (readonly)

Returns the value of attribute options



5
6
7
# File 'lib/bundler/cli/platform.rb', line 5

def options
  @options
end

Instance Method Details

#runObject



10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
# File 'lib/bundler/cli/platform.rb', line 10

def run
  platforms, ruby_version = Bundler.ui.silence do
    locked_ruby_version = Bundler.locked_gems && Bundler.locked_gems.ruby_version
    gemfile_ruby_version = Bundler.definition.ruby_version && Bundler.definition.ruby_version.single_version_string
    [Bundler.definition.platforms.map {|p| "* #{p}" },
     locked_ruby_version || gemfile_ruby_version]
  end
  output = []

  if options[:ruby]
    if ruby_version
      output << ruby_version
    else
      output << "No ruby version specified"
    end
  else
    output << "Your platform is: #{RUBY_PLATFORM}"
    output << "Your app has gems that work on these platforms:\n#{platforms.join("\n")}"

    if ruby_version
      output << "Your Gemfile specifies a Ruby version requirement:\n* #{ruby_version}"

      begin
        Bundler.definition.validate_runtime!
        output << "Your current platform satisfies the Ruby version requirement."
      rescue RubyVersionMismatch => e
        output << e.message
      end
    else
      output << "Your Gemfile does not specify a Ruby version requirement."
    end
  end

  Bundler.ui.info output.join("\n\n")
end